#!/usr/local/php/bin/php -q
<?
	$morse = array(
		'1' => '.----',
		'2' => '..---',
		'3' => '...--',
		'4' => '....-',
		'5' => '.....',
		'6' => '-....',
		'7' => '--...',
		'8' => '---..',
		'9' => '----.',
		'0' => '-----',

		'A' => '.-',
		'B' => '-...',
		'C' => '-.-.',
		'D' => '-..',
		'E' => '.',
		'F' => '..-.',
		'G' => '--.',
		'H' => '....',
		'I' => '..',
		'J' => '.---',
		'K' => '-.-',
		'L' => '.-..',
		'M' => '--',
		'N' => '-.',
		'O' => '---',
		'P' => '.--.',
		'Q' => '--.-',
		'R' => '.-.',
		'S' => '...',
		'T' => '-',
		'U' => '..-',
		'V' => '...-',
		'W' => '.--',
		'X' => '-..-',
		'Y' => '-.--',
		'Z' => '--..',
		
		'.' => '.-.-.-',
		',' => '--..--',
		'?' => '..--..',
		"'" => '.----.',
		'!' => '-.-.--',
		'/' => '-..-.',
		'(' => '-.--.',
		')' => '-.--.-',
		'&' => '.-...',
		':' => '---...',
		';' => '-.-.-.',
		'=' => '-...-',
		'+' => '.-.-.',
		'-' => '-....-',
		'_' => '..--.-',
		'"' => '.-..-.',
		'$' => '...-..',
		'@' => '.--.-.'
	);

	$wordSpace = '00';
	$charSpace = '01';
	$dit = '10';
	$dah = '11';

	if($_SERVER['argc'] > 1) {
		$fp = fopen($_SERVER['argv'][1], 'r');
		if(!$fp) die('Unable to open "' . $_SERVER['argv'][1] . '" for reading.');
	} else {
		$fp = fopen('php://stdin', 'r');
	}

	$first = true;
	$bitString = '';
	$msg = '';
	while(($char = fread($fp, 1)) !== '') {
		if($char == "\n" || $char == "\r") continue;
		$char = strtoupper($char);

		if($char == ' ') {
			$bitString .= $wordSpace;
			$message .= '  ';
		} else if(isset($morse[$char])) {
			if(!$first) {
				$bitString .= $charSpace;
				$message .= ' ';
			}
			$first = false;
			for($i = 0; $i < strlen($morse[$char]); $i++) {
				$bitString .= (($morse[$char][$i] == '.')?($dit):($dah));
			}
			$message .= strtoupper($char);
		} else {
			die('No morse known for char "' . $char . '".');
		}
	}
	fclose($fp);

	$out = '';
	$bytes = 0;
	for($i = 0; $i < strlen($bitString); $i+= 8) {
		$n = 0;
		for($j = 0; $j < 8; $j++) {
			$n |= ((($i+$j) < strlen($bitString) && $bitString[$i+$j] == '1')?(1 << 7-$j):(0));
		}
		$out .= sprintf("%s0x%0X", (($bytes)?(','):('')), $n);
		$bytes++;
	}
	printf("/* message: '%s' */\n", $message);
	printf("#define LENGTH %d\n", $bytes);
	printf("unsigned char morseData[%d] PROGMEM = {\n", $bytes);
	printf("\t%s\n", $out);
	printf("};\n");
?>
